#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './otrprefs.ui'
**
** Created: Fri Jan 25 11:08:23 2008
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.8   edited Jan 11 14:47 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "otrprefs.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qgroupbox.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <kactivelabel.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qtable.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "kactivelabel.h"

/*
 *  Constructs a OTRPrefsUI as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
OTRPrefsUI::OTRPrefsUI( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "OTRPrefsUI" );
    OTRPrefsUILayout = new QGridLayout( this, 1, 1, 11, 6, "OTRPrefsUILayout"); 

    twSettings = new QTabWidget( this, "twSettings" );

    settings = new QWidget( twSettings, "settings" );
    settingsLayout = new QGridLayout( settings, 1, 1, 11, 6, "settingsLayout"); 

    groupBox1 = new QGroupBox( settings, "groupBox1" );
    groupBox1->setColumnLayout(0, Qt::Vertical );
    groupBox1->layout()->setSpacing( 6 );
    groupBox1->layout()->setMargin( 11 );
    groupBox1Layout = new QGridLayout( groupBox1->layout() );
    groupBox1Layout->setAlignment( Qt::AlignTop );

    btGenFingerprint = new QPushButton( groupBox1, "btGenFingerprint" );

    groupBox1Layout->addWidget( btGenFingerprint, 0, 2 );

    cbKeys = new QComboBox( FALSE, groupBox1, "cbKeys" );
    cbKeys->setMaximumSize( QSize( 400, 32767 ) );

    groupBox1Layout->addWidget( cbKeys, 0, 1 );

    textLabel2 = new QLabel( groupBox1, "textLabel2" );

    groupBox1Layout->addWidget( textLabel2, 0, 0 );

    tlFingerprint = new KActiveLabel( groupBox1, "tlFingerprint" );
    tlFingerprint->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, 0, 0, tlFingerprint->sizePolicy().hasHeightForWidth() ) );

    groupBox1Layout->addMultiCellWidget( tlFingerprint, 1, 1, 0, 2 );

    settingsLayout->addWidget( groupBox1, 0, 0 );

    bgPolicy = new QButtonGroup( settings, "bgPolicy" );
    bgPolicy->setColumnLayout(0, Qt::Vertical );
    bgPolicy->layout()->setSpacing( 6 );
    bgPolicy->layout()->setMargin( 11 );
    bgPolicyLayout = new QGridLayout( bgPolicy->layout() );
    bgPolicyLayout->setAlignment( Qt::AlignTop );

    kcfg_rbOpportunistic = new QRadioButton( bgPolicy, "kcfg_rbOpportunistic" );

    bgPolicyLayout->addWidget( kcfg_rbOpportunistic, 1, 0 );

    kcfg_rbNever = new QRadioButton( bgPolicy, "kcfg_rbNever" );

    bgPolicyLayout->addWidget( kcfg_rbNever, 1, 1 );

    kcfg_rbManual = new QRadioButton( bgPolicy, "kcfg_rbManual" );
    kcfg_rbManual->setChecked( FALSE );

    bgPolicyLayout->addWidget( kcfg_rbManual, 0, 1 );

    kcfg_rbAlways = new QRadioButton( bgPolicy, "kcfg_rbAlways" );
    kcfg_rbAlways->setAutoMask( FALSE );
    kcfg_rbAlways->setChecked( FALSE );

    bgPolicyLayout->addWidget( kcfg_rbAlways, 0, 0 );

    settingsLayout->addWidget( bgPolicy, 1, 0 );
    spacer2 = new QSpacerItem( 20, 161, QSizePolicy::Minimum, QSizePolicy::Expanding );
    settingsLayout->addItem( spacer2, 2, 0 );
    twSettings->insertTab( settings, QString::fromLatin1("") );

    fingerprints = new QWidget( twSettings, "fingerprints" );
    fingerprintsLayout = new QGridLayout( fingerprints, 1, 1, 11, 6, "fingerprintsLayout"); 

    tbFingerprints = new QTable( fingerprints, "tbFingerprints" );
    tbFingerprints->setNumCols( tbFingerprints->numCols() + 1 );
    tbFingerprints->horizontalHeader()->setLabel( tbFingerprints->numCols() - 1, tr2i18n( "User" ) );
    tbFingerprints->setNumCols( tbFingerprints->numCols() + 1 );
    tbFingerprints->horizontalHeader()->setLabel( tbFingerprints->numCols() - 1, tr2i18n( "Status" ) );
    tbFingerprints->setNumCols( tbFingerprints->numCols() + 1 );
    tbFingerprints->horizontalHeader()->setLabel( tbFingerprints->numCols() - 1, tr2i18n( "Verified" ) );
    tbFingerprints->setNumCols( tbFingerprints->numCols() + 1 );
    tbFingerprints->horizontalHeader()->setLabel( tbFingerprints->numCols() - 1, tr2i18n( "Fingerprint" ) );
    tbFingerprints->setNumCols( tbFingerprints->numCols() + 1 );
    tbFingerprints->horizontalHeader()->setLabel( tbFingerprints->numCols() - 1, tr2i18n( "Protocol" ) );
    tbFingerprints->setNumRows( 1 );
    tbFingerprints->setNumCols( 5 );
    tbFingerprints->setShowGrid( TRUE );
    tbFingerprints->setReadOnly( TRUE );
    tbFingerprints->setSorting( FALSE );
    tbFingerprints->setSelectionMode( QTable::SingleRow );
    tbFingerprints->setFocusStyle( QTable::FollowStyle );

    fingerprintsLayout->addMultiCellWidget( tbFingerprints, 0, 0, 0, 1 );

    btVerify = new QPushButton( fingerprints, "btVerify" );
    btVerify->setEnabled( TRUE );

    fingerprintsLayout->addWidget( btVerify, 1, 0 );

    btForget = new QPushButton( fingerprints, "btForget" );
    btForget->setEnabled( FALSE );

    fingerprintsLayout->addWidget( btForget, 1, 1 );
    twSettings->insertTab( fingerprints, QString::fromLatin1("") );

    OTRPrefsUILayout->addWidget( twSettings, 0, 0 );
    languageChange();
    resize( QSize(480, 358).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
OTRPrefsUI::~OTRPrefsUI()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void OTRPrefsUI::languageChange()
{
    setCaption( tr2i18n( "Form1" ) );
    groupBox1->setTitle( tr2i18n( "Private Keys" ) );
    btGenFingerprint->setText( tr2i18n( "&Generate" ) );
    btGenFingerprint->setAccel( QKeySequence( tr2i18n( "Alt+G" ) ) );
    textLabel2->setText( tr2i18n( "Account:" ) );
    tlFingerprint->setText( tr2i18n( "No Fingerprint" ) );
    bgPolicy->setTitle( tr2i18n( "Default Policy" ) );
    kcfg_rbOpportunistic->setText( tr2i18n( "&Opportunistic" ) );
    kcfg_rbOpportunistic->setAccel( QKeySequence( tr2i18n( "Alt+O" ) ) );
    QToolTip::add( kcfg_rbOpportunistic, tr2i18n( "Encrypt messages automatically if the other side supports OTR" ) );
    kcfg_rbNever->setText( tr2i18n( "Ne&ver" ) );
    kcfg_rbNever->setAccel( QKeySequence( tr2i18n( "Alt+V" ) ) );
    QToolTip::add( kcfg_rbNever, tr2i18n( "Never encrypt messages" ) );
    kcfg_rbManual->setText( tr2i18n( "&Manual" ) );
    kcfg_rbManual->setAccel( QKeySequence( tr2i18n( "Alt+M" ) ) );
    QToolTip::add( kcfg_rbManual, tr2i18n( "Encrypt messages if the other side requests an OTR connection" ) );
    kcfg_rbAlways->setText( tr2i18n( "Al&ways" ) );
    kcfg_rbAlways->setAccel( QKeySequence( tr2i18n( "Alt+W" ) ) );
    QToolTip::add( kcfg_rbAlways, tr2i18n( "Always encrypt messages" ) );
    twSettings->changeTab( settings, tr2i18n( "&Settings" ) );
    tbFingerprints->horizontalHeader()->setLabel( 0, tr2i18n( "User" ) );
    tbFingerprints->horizontalHeader()->setLabel( 1, tr2i18n( "Status" ) );
    tbFingerprints->horizontalHeader()->setLabel( 2, tr2i18n( "Verified" ) );
    tbFingerprints->horizontalHeader()->setLabel( 3, tr2i18n( "Fingerprint" ) );
    tbFingerprints->horizontalHeader()->setLabel( 4, tr2i18n( "Protocol" ) );
    btVerify->setText( tr2i18n( "&Verify Fingerprint" ) );
    btVerify->setAccel( QKeySequence( tr2i18n( "Alt+V" ) ) );
    btForget->setText( tr2i18n( "F&orget Fingerprint" ) );
    btForget->setAccel( QKeySequence( tr2i18n( "Alt+O" ) ) );
    twSettings->changeTab( fingerprints, tr2i18n( "K&nown Fingerprints" ) );
}

void OTRPrefsUI::generateFingerprint()
{
    qWarning( "OTRPrefsUI::generateFingerprint(): Not implemented yet" );
}

#include "otrprefs.moc"
